﻿GupCharacter_Options = {
	"PLAYERSTAT_BASE_STATS", 
	"PLAYERSTAT_MELEE_COMBAT", 
	"PLAYERSTAT_DEFENSES", 
}
 
----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_OnLoad				 																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_OnEvent			 																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_OnEvent(self, event) --self, event, ...

	if event == "PLAYER_ENTERING_WORLD"  then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		
		PaperDollFrame:DisableDrawLayer("BACKGROUND"); 

		CharacterFrame:SetWidth(512);
		
		---------------------------------
		-- Character
		---------------------------------
		CharacterModelFrame:ClearAllPoints();
		CharacterModelFrame:SetPoint("TOPLEFT", GupCharacter_PaperDollFrame, "TOPLEFT", 129, -78)
		CharacterModelFrameRotateLeftButton:SetPoint( "TOPLEFT" , -64 , 0);
		 
		CharacterAttributesFrame:ClearAllPoints();
		
		CharacterResistanceFrame:ClearAllPoints();
		CharacterResistanceFrame:SetPoint("TOPRIGHT", GupCharacter_PaperDollFrame, "TOPLEFT", 425, -77) --297+128
		
		CharacterHeadSlot:ClearAllPoints();
		CharacterHeadSlot:SetPoint("TOPLEFT", GupCharacter_PaperDollFrame, "TOPLEFT", 21, -74)
		
		CharacterHandsSlot:ClearAllPoints();
		CharacterHandsSlot:SetPoint("TOPLEFT", GupCharacter_PaperDollFrame, "TOPLEFT", 433, -74) --305+128
		
		CharacterMainHandSlot:ClearAllPoints();
		CharacterMainHandSlot:SetPoint("TOPLEFT", GupCharacter_PaperDollFrame, "BOTTOMLEFT", 187, 127) --122+65
		
		PaperDollFrameItemFlyout:ClearAllPoints();
		PaperDollFrameItemFlyout:SetPoint("TOPRIGHT", GupCharacter_PaperDollFrame, "TOPRIGHT", 0, 0)
		
		GearManagerDialog:ClearAllPoints();
		GearManagerDialog:SetPoint("TOPLEFT", GupCharacter_PaperDollFrame, "TOPRIGHT", -38, -10)
		
		---------------------------------
		-- Pets
		---------------------------------		
		GupCharacter_Hide(PetPaperDollFrame);
		GupCharacter_Hide(PetPaperDollFrameCompanionFrame );
		
		PetPaperDollFrame:UnregisterEvent("PET_UI_UPDATE");
		PetPaperDollFrame:UnregisterEvent("PET_BAR_UPDATE");
		PetPaperDollFrame:UnregisterEvent("PET_UI_CLOSE");
		PetPaperDollFrame:UnregisterEvent("UNIT_NAME_UPDATE");
		PetPaperDollFrame:UnregisterEvent("UNIT_PET");
		PetPaperDollFrame:UnregisterEvent("UNIT_PET_EXPERIENCE");
		PetPaperDollFrame:UnregisterEvent("UNIT_MODEL_CHANGED");
		PetPaperDollFrame:UnregisterEvent("UNIT_LEVEL");
		PetPaperDollFrame:UnregisterEvent("UNIT_RESISTANCES");
		PetPaperDollFrame:UnregisterEvent("UNIT_STATS");
		PetPaperDollFrame:UnregisterEvent("UNIT_DAMAGE");
		PetPaperDollFrame:UnregisterEvent("UNIT_RANGEDDAMAGE");
		PetPaperDollFrame:UnregisterEvent("UNIT_ATTACK_SPEED");
		PetPaperDollFrame:UnregisterEvent("UNIT_ATTACK_POWER");
		PetPaperDollFrame:UnregisterEvent("UNIT_RANGED_ATTACK_POWER");
		PetPaperDollFrame:UnregisterEvent("UNIT_DEFENSE");
		PetPaperDollFrame:UnregisterEvent("UNIT_ATTACK");
		PetPaperDollFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
		PetPaperDollFrame:UnregisterEvent("COMPANION_LEARNED");
		PetPaperDollFrame:UnregisterEvent("COMPANION_UPDATE");
		PetPaperDollFrame:UnregisterEvent("SPELL_UPDATE_COOLDOWN");
		PetPaperDollFrame:UnregisterEvent("UNIT_ENTERED_VEHICLE");
		PetPaperDollFrame:UnregisterEvent("UNIT_EXITED_VEHICLE");

		PetPaperDollCloseButton:Hide(); --Close Button

		PetPaperDollFramePetFrame:ClearAllPoints();
		PetPaperDollFramePetFrame:SetPoint( "TOPLEFT", GupCharacter_PetPaperDollFramePetFrame, "TOPLEFT", 0, 0); 
		PetPaperDollFramePetFrame:SetPoint( "BOTTOMRIGHT", GupCharacter_PetPaperDollFramePetFrame, "BOTTOMRIGHT", 0, 0); 
		
		-------- Pets
		PetModelFrame:ClearAllPoints();
		PetModelFrame:SetPoint( "TOPLEFT", PetPaperDollFramePetFrame, "TOPLEFT", 89, -78); --25+64
		
		PetPaperDollFrameExpBar:ClearAllPoints();
		PetPaperDollFrameExpBar:SetPoint( "BOTTOMLEFT", PetPaperDollFramePetFrame, "BOTTOMLEFT", 87, 83); --23+64
		
		PetAttributesFrame:ClearAllPoints();
		PetAttributesFrame:SetPoint( "TOPLEFT", PetPaperDollFramePetFrame, "TOPLEFT", 131, -320); --67+64
		
		PetResistanceFrame:ClearAllPoints();
		PetResistanceFrame:SetPoint( "TOPLEFT", PetPaperDollFramePetFrame, "TOPLEFT", 434, -76); --338+96
		
		-------- Companions / Mounts
		
		PetPaperDollFrameCompanionFrame:ClearAllPoints();
		
		CompanionModelFrameRotateLeftButton:ClearAllPoints();
		CompanionModelFrameRotateLeftButton:SetPoint( "TOPLEFT", GupCharacter_PetPaperDollFrameCompanionFrame, "TOPLEFT", 23, -76);
	
		CompanionModelFrame:ClearAllPoints();
		CompanionModelFrame:SetPoint( "TOPLEFT" , GupCharacter_PetPaperDollFrameCompanionFrame, "TOPLEFT" , 103 , -80); --39+64

		CompanionPrevPageButton:ClearAllPoints();
		CompanionButton1:ClearAllPoints();
		CompanionSelectedName:ClearAllPoints();
		CompanionPageNumber:ClearAllPoints();
		
		CompanionSummonButton:ClearAllPoints();
		CompanionSummonButton:SetPoint( "CENTER" , GupCharacter_PetPaperDollFrameCompanionFrame,  "CENTER" ,-13 , -5);
		
		NUM_COMPANIONS_PER_PAGE = 0 ;

		PetPaperDollFrameTab2:ClearAllPoints();
		PetPaperDollFrameTab3:ClearAllPoints();
		PetPaperDollFrameTab1:ClearAllPoints();
				
		---------------------------------
		-- Reputation
		---------------------------------				
		GupCharacter_Hide(ReputationFrame);
				
		ReputationFrameStandingLabel:ClearAllPoints();
		ReputationFrameStandingLabel:SetPoint( "TOPLEFT", ReputationFrame, "TOPLEFT", 359, -59); --215+128+16
				
		hooksecurefunc("ReputationFrame_SetRowType", function(factionRow, rowType, hasRep)
 
			local factionRowName = factionRow:GetName()
			local factionBar = getglobal(factionRowName.."ReputationBar");
 
		end)
		
		
		---------------------------------
		-- Skills
		---------------------------------	
		GupCharacter_Hide(SkillFrame);
		SkillFrameCancelButton:Hide();  --Close Button
			
		SKILLS_TO_DISPLAY = 14 ;
		
		for i=1, SKILLS_TO_DISPLAY do
			getglobal("SkillRankFrame"..i):SetWidth(399);
			getglobal("SkillRankFrame"..i.."Border"):SetWidth(409);
		end
		
		SkillListScrollFrame:SetWidth(427);
		SkillListScrollFrame:SetHeight(255);
		
		SkillDetailScrollFrame:SetWidth(427);
		SkillDetailScrollFrame:SetHeight(99);
		
		SkillDetailScrollChildFrame:SetWidth(448);
		SkillDetailCostText:SetWidth(328);
		SkillDetailDescriptionText:SetWidth(328);
		
		GupCharacter_Hide(SkillListScrollFrame);
		GupCharacter_Hide(SkillDetailScrollFrame);
		
		---------------------------------
		-- currency
		---------------------------------	
		GupCharacter_Hide(TokenFrame);
		TokenFrameCancelButton:Hide(); --Close Button
		TokenFrameContainer:SetWidth(427); --299+128
		TokenFrameContainer:SetHeight(350); --330+20
		
		TokenFrameMoneyFrame:ClearAllPoints();
		TokenFrameMoneyFrame:SetPoint( "TOPLEFT", TokenFrame, "TOPLEFT", 359, -59); --215+128+16
		
		TokenFrameContainerScrollBar.Show = 
		function (self)
			TokenFrameContainer:SetWidth(427); --299+128
			for _, button in next, getglobal("TokenFrameContainer").buttons do
				button:SetWidth(423); --295+128
				getglobal(button:GetName().."Name"):SetWidth(343);
			end
			getmetatable(self).__index.Show(self);
		end
		
		TokenFrameContainerScrollBar.Hide = 
			function (self)
				TokenFrameContainer:SetWidth(441); --313+128
				for _, button in next, TokenFrameContainer.buttons do
					button:SetWidth(441); --313+128
				end
				getmetatable(self).__index.Hide(self);
			end		
	elseif event == "VARIABLES_LOADED" then
	end
 
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_PaperDollFrame_SetLevel																]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_PaperDollFrame_SetLevel()
	GupCharacter_CharacterLevelText:SetFormattedText(PLAYER_LEVEL, UnitLevel("player"), UnitRace("player"), UnitClass("player"));
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_PlayerStatFrameDropDown_OnLoad															]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_PlayerStatFrameDropDown_OnLoad (self )
	RaiseFrameLevel(self);
	UIDropDownMenu_Initialize(self, GupCharacter_PlayerStatFrameDropDown_Initialize);
	UIDropDownMenu_SetSelectedValue(self, GupCharacter_Options[self.nr]);
	UIDropDownMenu_SetWidth(self, 99);
	UIDropDownMenu_JustifyText(self, "LEFT");
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_PlayerStatFrameDropDown_OnShow															]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_PlayerStatFrameDropDown_OnShow (self)
	UIDropDownMenu_Initialize(self, GupCharacter_PlayerStatFrameDropDown_Initialize);
	UIDropDownMenu_SetSelectedValue(self,  GupCharacter_Options[ self.nr  ]);
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_PlayerStatFrameDropDown_Initialize														]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_PlayerStatFrameDropDown_Initialize (self)
	-- Setup buttons
	local info = UIDropDownMenu_CreateInfo();
	local checked;
	for i=1, getn(PLAYERSTAT_DROPDOWN_OPTIONS) do
		if ( PLAYERSTAT_DROPDOWN_OPTIONS[i] == GupCharacter_Options[ self.nr ] ) then
			checked = 1;
		else
			checked = nil;
		end
		info.text = getglobal(PLAYERSTAT_DROPDOWN_OPTIONS[i]);
		info.func = GupCharacter_PlayerStatFrameDropDown_OnClick ;
		info.value = PLAYERSTAT_DROPDOWN_OPTIONS[i];
		info.checked = checked;
		info.owner = UIDROPDOWNMENU_OPEN_MENU;
		info.nr = self.nr ;
		UIDropDownMenu_AddButton(info);
	end
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_PlayerStatFrameDropDown_OnClick														]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_PlayerStatFrameDropDown_OnClick(self)
	UIDropDownMenu_SetSelectedValue(self.owner, self.value);
	GupCharacter_Options[ self.owner.nr ] =  self.value ;
	UpdatePaperdollStats("GupCharacter_PlayerStatFrame"..self.owner.nr , self.value);
end

----------------------------------------------------------------------------------------------------------------
--[[	hooksecurefunc																						]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
hooksecurefunc("PaperDollFrame_SetLevel", GupCharacter_PaperDollFrame_SetLevel )
 
hooksecurefunc("PaperDollFrame_UpdateStats", function()
	UpdatePaperdollStats("GupCharacter_PlayerStatFrame1", GupCharacter_Options[1])
	UpdatePaperdollStats("GupCharacter_PlayerStatFrame2", GupCharacter_Options[2])
	UpdatePaperdollStats("GupCharacter_PlayerStatFrame3", GupCharacter_Options[3])	
end)

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_Hide																					]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupCharacter_Hide(frame)

	if not frame then return end

	for i = 1, frame:GetNumRegions() do
		local reg = select(i, frame:GetRegions())
		
		if not reg:IsObjectType("FontString")  then
			if not hide then reg:SetAlpha(0) else reg:Hide() end
		end
	end

	for i = 1, frame:GetNumChildren() do
		local reg = select(i, frame:GetChildren())
		
		 reg:SetFrameLevel ( reg:GetFrameLevel()+1 )  ;
	end 
end

----------------------------------------------------------------------------------------------------------------
--[[	GupCharacter_ToggleCharacter																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
hooksecurefunc("ToggleCharacter", function(tab) GupCharacter_ToggleCharacter(tab) end);

function  GupCharacter_ToggleCharacter (tab)
 
	GupCharacter_PetPaperDollFrame:Hide();
	GupCharacter_ReputationFrame:Hide();
	GupCharacter_SkillFrame:Hide();
	GupCharacter_TokenFrame:Hide();

	if ( tab == "PaperDollFrame" ) then
	elseif ( tab == "PetPaperDollFrame" ) then
		GupCharacter_PetPaperDollFrame:Show();
	elseif ( tab == "ReputationFrame" ) then
		GupCharacter_ReputationFrame:Show();
	elseif ( tab == "SkillFrame" ) then
		GupCharacter_SkillFrame:Show();
	elseif ( tab == "TokenFrame" ) then
		GupCharacter_TokenFrame:Show();
	end
	
end

