
local class = select(2, _G.UnitClass("player"))
if class ~= "ROGUE" and class ~= "WARRIOR" and class ~= "HUNTER" and class ~= "WARLOCK" then
	DisableAddOn("StatBlock_Ammo")
	ChatFrame1:AddMessage("StatBlock_Ammo: ".. _G["ADDON_DISABLED"])
	return
end

local Ammo = _G.CreateFrame("Frame", "StatBlock_Ammo")
Ammo.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Ammo", {type = "data source", icon = "Interface\\Icons\\INV_Misc_Ammo_Arrow_02", text = 0})

local ammoSlotID = _G.GetInventorySlotInfo("AmmoSlot")
local rangedSlotID = _G.GetInventorySlotInfo("RangedSlot")
local GetInventoryItemCount = _G.GetInventoryItemCount
local GetInventoryItemDurability = _G.GetInventoryItemDurability
local InCombatLockdown = _G.InCombatLockdown
local player = "player"
local GetItemCount = _G.GetItemCount

Ammo:SetScript("OnEvent", function(_, event) Ammo[event](Ammo) end)
Ammo:RegisterEvent("PLAYER_LOGIN")

function Ammo:PLAYER_LOGIN()
	if class == "WARLOCK" then
		self:RegisterEvent("BAG_UPDATE")
		self.obj.icon = "Interface\\Icons\\INV_Misc_Gem_Amethyst_02"
		self.obj.text = GetItemCount(6265) or 0
	else
		local link = _G.GetInventoryItemLink(player, rangedSlotID)
		if not link then return end
		local loc = select(9, _G.GetItemInfo(link))
		if loc == "INVTYPE_THROWN" then
			self:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
			self.obj.icon = GetInventoryItemTexture(player, rangedSlotID) or self.obj.icon
		else
			self:RegisterEvent("ACTIONBAR_HIDEGRID")
			self:RegisterEvent("UNIT_INVENTORY_CHANGED")
			self.obj.icon = GetInventoryItemTexture(player, ammoSlotID) or self.obj.icon
		end
		self:RegisterEvent("MERCHANT_CLOSED")
		self:RegisterEvent("PLAYER_ENTERING_WORLD") --incase we zone with merchant open
	end
	self.PLAYER_LOGIN = nil
end

function Ammo:BAG_UPDATE()
	self.obj.text = GetItemCount(6265) or self.obj.text
end

function Ammo:UNIT_INVENTORY_CHANGED()
	self.obj.text = InCombatLockdown() and GetInventoryItemCount(player, ammoSlotID) or self.obj.text
end

function Ammo:UPDATE_INVENTORY_DURABILITY()
	self.obj.text = InCombatLockdown() and GetInventoryItemDurability(rangedSlotID) or self.obj.text
end

function Ammo:MERCHANT_CLOSED()
	self.obj.text = class == "HUNTER" and GetInventoryItemCount(player, ammoSlotID) or GetInventoryItemDurability(rangedSlotID) or self.obj.text
end
Ammo.PLAYER_ENTERING_WORLD = Ammo.MERCHANT_CLOSED

function Ammo:ACTIONBAR_HIDEGRID()
	local prev = 0
	--short timer to make up for server lag, this is for hunters ammo swapping.
	self:SetScript("OnUpdate", function(_, e)
		prev = prev + e
		if prev > 1 then
			self:SetScript("OnUpdate", nil)
			self.obj.text = GetInventoryItemCount(player, ammoSlotID) or self.obj.text
			self.obj.icon = GetInventoryItemTexture(player, ammoSlotID) or self.obj.icon
		end
	end)
end

