﻿
local Money = _G.CreateFrame("Frame", "StatBlock_Money")
Money.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Money", {type = "data source"})

local L_GOLD = "g"
local L_SILVER = "s"
local L_COPPER = "c"

local L = GetLocale()
if L == "frFR" then
	L_GOLD = "o"
	L_SILVER = "a"
	L_COPPER = "c"
end

local function shValue(n)
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end

Money:SetScript("OnEvent", function()
	local current = _G.GetMoney()
	local gold = floor(current / 10000)
	local silver = floor((current - (gold * 10000)) / 100)
	local copper = mod(current, 100)
	gold = shValue(gold)
	
	Money.obj.text = format("%s|cffffd700%s|r %i|cffc7c7cf%s|r %i|cffeda55f%s|r", gold, L_GOLD, silver, L_SILVER, copper, L_COPPER)
	
end)

Money:RegisterEvent("PLAYER_MONEY")
Money:RegisterEvent("PLAYER_TRADE_MONEY")
Money:RegisterEvent("TRADE_MONEY_CHANGED")
Money:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
Money:RegisterEvent("SEND_MAIL_COD_CHANGED")
Money:RegisterEvent("PLAYER_LOGIN")
