--edited by shUI--
--NOTE: I heavily used tekkub coding for this mod, I added on a bunch of my code to his code to create the two new databrokers!

------------------CONFIG---------------------
--NOTE: databrokers will always update in real time, this is just configuring the tooltip
local wantOnClickUpdating = false -->false: updates tooltip continously in real-time (resource heavy) and true: updates tooltip only on clicking data broker

local wantAlphaSorting = false-->false: sorts addon list by usage (descending) and true: sorts addon list in alphabetical order

local wantOnlyAddonUsage = true -->false: data broker will display TOTAL UI mem usage and true: data broker will display just ADDON mem usage

local wantColoring = true -->true: colors addon names AND memusage and false: just colors memusage and applies "cyan" to addon name

local UPDATEPERIOD = 1 -->number (seconds) that your data broker AND tooltip will be updated (only if wantOnClick is set to "FALSE")

local MEMTHRESH = 30 -->number (kb) that will limit addon visibility, anything less than this number will NOT show in tooltip

local colorgradient = 40 -->number that corresponds to the top "red" value of your addon usage..used for gradience and Tekkub color gradient function

local maxaddons = 55 --[[max number of addons that will be displayed in tooltip. NOTE: if you are using alphabetical sorting it will NOT display all addons and will 
cut off based on this number.  Keep default value of 100 if you do not want that to happen]]
------------------END of CONFIG---------------

if collectgarbage then collectgarbage("collect") end

if not LibStub then error("sh:Performance requires LibStub") end

local prevmem, elapsed, tipshownMem, tipshownLatency = collectgarbage("count"), 0.5
local format, modf, GetNetStats, GetFramerate, collectgarbage = string.format, math.modf, GetNetStats, GetFramerate, collectgarbage
local UpdateAddOnMemoryUsage, GetAddOnMemoryUsage, GetAddOnInfo = UpdateAddOnMemoryUsage, GetAddOnMemoryUsage, GetAddOnInfo

--ADDED extra set of icons, if you want to see what they look like go ahead and just add the number "2" to end of next three lines
local fpsIcon = "Interface\\AddOns\\shPerformance\\media\\fpsicon"
local memIcon = "Interface\\AddOns\\shPerformance\\media\\memicon"
local msIcon = "Interface\\AddOns\\shPerformance\\media\\msicon"

--create table of addons
local addons = {}
for i=1,GetNumAddOns() do 
	name = GetAddOnInfo(i)
	table.insert(addons, name) 
end 

-->sort alphabetically (default/automatic)
table.sort(addons, function(a,b) return a and b and a:lower() < b:lower() end) 

-->sort based on usage (will check to see what usage in tooltip updater)
local function usageSort(a,b) 
	local aMem = GetAddOnMemoryUsage(a)
	local bMem = GetAddOnMemoryUsage(b)
	return aMem > bMem
end

--TEKKUB created function for color gradience, awesome!--
local function ColorGradient(perc, r1, g1, b1, r2, g2, b2, r3, g3, b3)
	if perc >= 1 then return r3, g3, b3 elseif perc <= 0 then return r1, g1, b1 end
	local segment, relperc = modf(perc*2)
	if segment == 1 then r1, g1, b1, r2, g2, b2 = r2, g2, b2, r3, g3, b3 end
	return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end

--create seperate dataobjects for each tooltip to not mess with each other
local fmem = CreateFrame("frame")
local ffps = CreateFrame("frame")
local flatency = CreateFrame("frame")

local datafps = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("shFPS", {
	type = "data source", 
	text = "##.# fps", 
	icon = fpsIcon }) 

local datamem = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("shMem", {
	type = "data source", 
	text = "#.## mb", 
	icon = memIcon })
	
local datalatency = LibStub:GetLibrary("LibDataBroker-1.1"): NewDataObject("shLatency", {
	type = "data source", 
	text = "## ms", 
	icon = msIcon })

fmem:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0	
	
	local myAddOnMem = 0
	UpdateAddOnMemoryUsage()
	for i=1, GetNumAddOns() do 
		myAddOnMem = (myAddOnMem + GetAddOnMemoryUsage(i)) 
	end	
	
	local r, g, b
	
	if wantOnlyAddonUsage == false then -->will display TOTAL UI addon usage 
		UpdateAddOnMemoryUsage()
		local totalmemusage = collectgarbage("count")
		r, g, b = ColorGradient(totalmemusage/(70*1024), 0,1,0, 1,1,0, 1,0,0)
		if totalmemusage < 1024 then datamem.text = format("|cff%02x%02x%02x%.0f|r kb", r*255, g*255, b*255, totalmemusage)	
		else datamem.text = format("|cff%02x%02x%02x%.2f|r mb", r*255, g*255, b*255, totalmemusage/1024) end
	else
		r, g, b = ColorGradient(myAddOnMem/(50*1024), 0,1,0, 1,1,0, 1,0,0)
		if myAddOnMem < 1024 then datamem.text = format("|cff%02x%02x%02x%.0f|r kb", r*255, g*255, b*255, myAddOnMem)	
		else datamem.text = format("|cff%02x%02x%02x%.2f|r mb", r*255, g*255, b*255, myAddOnMem/1024) end
	end	
	
	--if user wants live/continous updates
	if tipshownMem then 
		if wantOnClickUpdating == false then datamem.OnEnter(tipshownMem) end
	end	
end)

ffps:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	
	local fps = GetFramerate()
	local r, g, b = ColorGradient(fps/75, 1,0,0, 1,1,0, 0,1,0)
	datafps.text = format("|cff%02x%02x%02x%.0f|r fps", r*255, g*255, b*255, fps)	
end)

flatency:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	
	local latency = select(3, GetNetStats())
	local r, g, b = ColorGradient(latency/1000, 0,1,0, 1,1,0, 1,0,0)
	datalatency.text = format("|cff%02x%02x%02x%.0f|r ms", r*255, g*255, b*255, latency)		
	if tipshownLatency then datalatency.OnEnter(tipshownLatency) end
end)

--edited for visual appeal: MEMORY TOOLTIP:shUI edit 
local function GetTipAnchor(frame)
	local x,y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

function datamem.OnLeave() 
	GameTooltip:Hide()
	tipshownMem = nil	
end

function datafps.OnLeave() 
	GameTooltip:Hide()	
end

function datalatency.OnLeave() 
	GameTooltip:Hide()	
	tipshownLatency = nil
end

--tooltip display of information
function datalatency.OnEnter(self)
	tipshownLatency = self
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(GetTipAnchor(self))
	GameTooltip:ClearLines()
	
	GameTooltip:AddLine("|cff0062ffsh|r|cff0DEB11Latency|r")
	GameTooltip:AddLine(format("|cffc3771aDataBroker|r based addon to show your network latency (ms)\nupdated every |cff06DDFA%s second(s)|r!\n", UPDATEPERIOD))
	
	local binz, boutz, _ = GetNetStats()
	local rin, gin, bins = ColorGradient(binz/20, 0,1,0, 1,1,0, 1,0,0)
	local rout, gout, bout = ColorGradient(boutz/5, 0,1,0, 1,1,0, 1,0,0)
	
	GameTooltip:AddDoubleLine("|cff06ddfaIncoming bandwidth|r (download) usage:", format("%.2f kb|cff06ddfa/sec|r", binz), nil, nil, nil, rin, gin, bins)
	GameTooltip:AddDoubleLine("|cff06ddfaOutgoing bandwidth|r (upload) usage:", format("%.2f kb|cff06ddfa/sec|r", boutz), nil, nil, nil, rout, gout, bout)	
	GameTooltip:AddLine("\n|cffC3771ALatency|r |cff06ddfa(def)|r: Latency (or delay) is an expression of how long it\ntakes for a packet of data to get from one point to another")
	GameTooltip:Show()
end

function datafps.OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(GetTipAnchor(self))
	GameTooltip:ClearLines()
	
	GameTooltip:AddLine("|cff0062ffsh|r|cff0DEB11FPS|r\n")
	GameTooltip:AddLine(format("|cffc3771aDataBroker|r based addon to show your \nframes per seconds updated every |cff06DDFA%s second(s)|r!", UPDATEPERIOD))	
	
	GameTooltip:Show()
end

function datamem.OnEnter(self)
	tipshownMem = self
 	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(GetTipAnchor(self))
	GameTooltip:ClearLines()
	
	UpdateAddOnMemoryUsage()

	GameTooltip:AddLine("|cff0062ffsh|r|cff0DEB11Performance|r")
	
	local fps = GetFramerate()
	local r, g, b = ColorGradient(fps/75, 1,0,0, 1,1,0, 0,1,0)
	GameTooltip:AddDoubleLine("\n|cff06ddfaFPS:|r",format("\n|cff%02x%02x%02x%.1f|r ", r*255, g*255, b*255, fps))
	
	local latency = select(3, GetNetStats())
	local x, y, z = ColorGradient(latency/1000, 0,1,0, 1,1,0, 1,0,0)
	GameTooltip:AddDoubleLine("|cff06ddfaLatency:|r", format("|cff%02x%02x%02x%.0f ms|r", x*255, y*255, z*255, latency))
	
	GameTooltip:AddLine(format("|cffc3771aDataBroker|r based addon to show your |cff06ddfaaddon|r memory\nupdated every |cff06DDFA%s second(s)|r!\n", UPDATEPERIOD))
	
	GameTooltip:AddDoubleLine("# | |cffC3771AAddon|r |cff06ddfaName|r", format("|cffC3771AMemory|r above (|cff06ddfa%s kb|r)", MEMTHRESH))
	GameTooltip:AddDoubleLine("|cffffffff------------|r", "|cffffffff------------|r")
	
	local addonmem = 0
	local counter = 0 -- for displaying purposes (listing)
	
	if wantAlphaSorting == false then
		table.sort(addons, usageSort) -->sort numerically by usage (descending) if desired
	end	
	
	for i,name in ipairs(addons) do		
		local mem = GetAddOnMemoryUsage(name)
		local r, g, b = ColorGradient((mem - MEMTHRESH)/1024, 0,1,0, 1,1,0, 1,0,0)
		addonmem = addonmem + mem
		if mem > MEMTHRESH  and maxaddons > counter and name ~= 'shPerformance' then
			counter = counter + 1
			if wantColoring then
				local memstr = mem > 1024 and format("%.2f mb", mem/1024) or format("%.1f kb", mem)
				if counter < 10 then GameTooltip:AddDoubleLine(format("  |cffDAB024%.0f)|r %s", counter, name), memstr, r, g, b, r, g, b)  
				else GameTooltip:AddDoubleLine(format("|cffDAB024%.0f)|r %s", counter, name), memstr, r, g, b, r, g, b) end
			else
				local memstr = mem > 1024 and format("%.2f mb", mem/1024) or format("%.1f kb", mem)
				if counter < 10 then GameTooltip:AddDoubleLine(format("  |cffDAB024%.0f)|r %s", counter, name), memstr, 6/255, 221/255, 250/255, r, g, b)  
				else GameTooltip:AddDoubleLine(format("|cffDAB024%.0f)|r %s", counter, name), memstr, 6/255, 221/255, 250/255, r, g, b) end
			end
		end
	end	
	
	GameTooltip:AddDoubleLine("|cffffffff------------|r", "|cffffffff------------|r")
	
	local r, g, b = ColorGradient(addonmem/(colorgradient*1024), 0,1,0, 1,1,0, 1,0,0)
	
	--Always shows shPerformance usage at bottom and not in list
	GameTooltip:AddDoubleLine("|cff0062ffsh|r|cff0DEB11Performance|r memory usage:", format("|cff0deb11%.2f kb|r", GetAddOnMemoryUsage('shPerformance')))
	GameTooltip:AddLine(" ")
	
	if addonmem > 1000 then
		GameTooltip:AddDoubleLine("|cffC3771ATotal Addon|r memory usage:", format("%.2f mb", addonmem/1024), nil,nil,nil, r,g,b)
	else 
		GameTooltip:AddDoubleLine("|cffC3771ATotal Addon|r memory usage:", format("%.2f kb", addonmem), nil,nil,nil, r,g,b) end

	local mem = collectgarbage("count")
	local deltamem = mem - prevmem
	prevmem = mem
	local r, g, b = ColorGradient(mem/(50*1024), 0,1,0, 1,1,0, 1,0,0)
	GameTooltip:AddDoubleLine("|cffC3771ADefault Blizzard UI|r memory usage:", format("%.2f mb", (mem-addonmem)/1024), nil,nil,nil, r,g,b)
	
	local r, g, b = ColorGradient(mem/((colorgradient+30)*1024), 0,1,0, 1,1,0, 1,0,0)
	GameTooltip:AddDoubleLine("|cff06DDFATOTAL UI|r memory usage:", format("%.2f mb", mem/1024), nil,nil,nil, r,g,b)
	
	if wantOnClickUpdating == false then
		GameTooltip:AddLine(" ")
		local r, g, b = ColorGradient(deltamem/15, 0,1,0, 1,1,0, 1,0,0)
		GameTooltip:AddDoubleLine("|cffc3771aGarbage|r |cff06ddfachurn:|r", format("%.2f kb/sec", deltamem), nil,nil,nil, r,g,b)
	end

	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("|cff0deb11Click|r to force |cffc3771agarbage collection|r and to |cff06ddfaupdate|r tooltip!")
	
	GameTooltip:Show()	
end

--replaces onclick function in data broker, for updates
function datamem.OnClick(self)
	if wantClickUpdating == true then datamem.OnEnter(self) end -->renders tooltip again for updating
	
	--inspired by LynStats (to print out garbage collection amount)
	UpdateAddOnMemoryUsage()
	local before = gcinfo()
	collectgarbage("collect")
	UpdateAddOnMemoryUsage()
	local after = gcinfo()
	local deltamem = before-after
	if deltamem > 1024 then
		print(format("|cff0DEB11shPerformance|r - |cffC3771AGarbage|r Collected: |cff0deb11%.2f|r |cff06ddfamb|r", deltamem/1024))
	else 
		print(format("|cff0DEB11shPerformance|r - |cffC3771AGarbage|r Collected: |cff0deb11%.0f|r |cff06ddfakb|r", deltamem)) 
	end
end